/*
 * "Hello World" example.
 *
 * This example prints 'Hello from Nios II' to the STDOUT stream. It runs on
 * the Nios II 'standard', 'full_featured', 'fast', and 'low_cost' example
 * designs. It runs with or without the MicroC/OS-II RTOS and requires a STDOUT
 * device in your system's hardware.
 * The memory footprint of this hosted application is ~69 kbytes by default
 * using the standard reference design.
 *
 * For a reduced footprint version of this template, and an explanation of how
 * to reduce the memory footprint for a given application, see the
 * "small_hello_world" template.
 *
 */
#include <system.h>
#include <stdio.h>
#include <io.h>
#include <sys/alt_irq.h>
#include <alt_types.h>

///////////////////////////
#include <time.h>
#include <unistd.h>

#ifdef __unix__
# include <unistd.h>
#elif defined _WIN32
# include <windows.h>
#define sleep(x) Sleep(1000 * x)
#endif

//////////////////////////


////////////////////////////////////////////////////////////////////


volatile int val = 0;
volatile int key = 0;

// for beats
volatile int beat_counter = 0;

// I set the displayed key each time val is incremented.

static void irqhandler (void * context, alt_u32 id)
{
    val ++;
key = 1;
IOWR_8DIRECT(INPUTCONTROLLER_INST_BASE, 0, 0); // reset request
}

static void irqhandler2 (void * context, alt_u32 id)
{
    val ++;
key = 2;
IOWR_8DIRECT(INPUTCONTROLLER2_INST_BASE, 0, 0); // reset request
}

static void irqhandler3 (void * context, alt_u32 id)
{
    val ++;
key = 3;
IOWR_8DIRECT(INPUTCONTROLLER3_INST_BASE, 0, 0); // reset request
}

static void irqhandler4 (void * context, alt_u32 id)
{
    val ++;
key = 4;
IOWR_8DIRECT(INPUTCONTROLLER4_INST_BASE, 0, 0); // reset request
}

static void irqhandler5 (void * context, alt_u32 id)
{
    //beat_counter = beat_counter+1;
    val ++;
key = 5;
IOWR_8DIRECT(INPUTCONTROLLER5_INST_BASE, 0, 0); // reset request
}

static void irqhandler6 (void * context, alt_u32 id)
{
     beat_counter = beat_counter+2;//2 coups de clock
    //val ++;
//key = 6;
IOWR_8DIRECT(INPUTCONTROLLER6_INST_BASE, 0, 0); // reset request
}

/////////////////////////////////////////////////////////////////////////////////////

volatile int valz = 0; 
void set_timer(int sec, int millis){
    
    long val = sec*1000+millis;
    long tics = val * 50000 ; //50Mhz
    
   // printf("%d\n",tics);
   
   /////////////////////////////////////////////////////////////
   ///////////////////////////////////////////////////////////// 
   // val = IORD_16DIRECT(TIMER_INST_BASE, 2);
   // val = val << 16;
   // val = val + IORD_16DIRECT(TIMER_INST_BASE, 0);
    
   // printf("%d\n",val);
   // printf("%d\n",IORD_16DIRECT(TIMER_INST_BASE, 0));
   // printf("%d\n",IORD_16DIRECT(TIMER_INST_BASE, 2));
    
    
  //  printf("\n%d\n",tics&0xFFFF0000);
   // printf("%d\n",tics&0x0000FFFF);
    
    
   // printf("\n%d\n",tics&0xFFFF0000 >> 16);
   // printf("%d\n\n",tics&0xFFFF0000 << 16);
    
  // printf("\n%d\n",tics&0x0000FFFF >> 16);
   // printf("%d\n\n",tics&0x0000FFFF << 16);
   
    /////////////////////////////////////////////////////////////
   ///////////////////////////////////////////////////////////// 
    
    // peut-etre probleme vient de fichier vhdl
    // ATTENTION, decommenter
   // IOWR_16DIRECT(TIMER_INST_BASE, 2, (tics&0xFFFF0000) >> 16); //MSB
   // IOWR_16DIRECT(TIMER_INST_BASE, 0, tics&0x0000FFFF); //LSB
    
   /////////////////////////////////////////////////////////////
   ///////////////////////////////////////////////////////////// 
   // val = IORD_16DIRECT(TIMER_INST_BASE, 2);
   // val = val << 16;
   // val = val + IORD_16DIRECT(TIMER_INST_BASE, 0);
    
   // printf("%d\n",val);
  //   printf("%d\n",IORD_16DIRECT(TIMER_INST_BASE, 0));
   // printf("%d\n",IORD_16DIRECT(TIMER_INST_BASE, 2));
    /////////////////////////////////////////////////////////////
   ///////////////////////////////////////////////////////////// 
}

void launch_timer(){
  //  IOWR_16DIRECT(TIMER_INST_BASE, 4, 0xffff); 
}
long read_timer(){
  //  long val = IORD_16DIRECT(TIMER_INST_BASE, 2);
    val = val << 16;
  //  val = val + IORD_16DIRECT(TIMER_INST_BASE, 0);
    
    //printf("%d\n",val);
    
    return val;
    
}

int timer_expired(){
  volatile long c = read_timer();
  
 // printf("%d\n",c);
  
   if (c== 0)
    return 1;
   return 0;
}



typedef struct note{
    int color ;
    int timestamp;   
}note; 



///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

int beats[] = {0x00b4,0x00c8,0x00f0,0x0116,0x0141,0x016a,0x0193,0x01bb,0x01e3,0x020a,0x0232,0x025a,0x0281,0x02a8,0x02d1,
0x02fa,0x0321,0x0348,0x0370,0x039a,0x03c1,0x03eb,0x0414,0x043a,0x0463,0x048a,0x04b3,0x04da,0x0503,0x052b,
0x0553,0x057a,0x05a2,0x05ca,0x05f2,0x061a,0x0642,0x066a,0x0692,0x06ba,0x06e2,0x0709,0x0731,0x0759,0x0781,
0x07a8,0x07d0,0x07f8,0x0820,0x0848,0x0872,0x0898,0x08bd,0x08e4,0x090c,0x0933,0x095a,0x0981,0x09ac,0x09d7,
0x0a00,0x0a25,0x0a4c,0x0a75,0x0a9c,0x0ac4,0x0aef,0x0b17,0x0b40,0x0b68,0x0b8f,0x0bb6,0x0bde,0x0c06,0x0c2f,
0x0c56,0x0c7e,0x0ca6,0x0cce,0x0cf6,0x0d1e,0x0d45,0x0d70,0x0d98,0x0dc0,0x0de4,0x0e0c,0x0e34,0x0e5c,0x0e85,
0x0eac,0x0ed4,0x0efb,0x0f24,0x0f4b,0x0f71,0x0f98,0x0fc2,0x0feb,0x1014,0x103c,0x1064,0x108b,0x10b3,0x10db,
0x1103,0x112b,0x1153,0x117b,0x11a2,0x11cb,0x11f2,0x121a,0x1243,0x126c,0x1292,0x12bb,0x12e2,0x130a,0x1332,
0x135a,0x1382,0x13aa,0x13d1,0x13f9,0x1421,0x144a,0x1471,0x1499,0x14c2,0x14e8,0x1510,0x153a,0x1560,0x1588,
0x15b0,0x15d9,0x15ff,0x1628,0x164f,0x1677,0x169f,0x16c7,0x16ee,0x1717,0x173f,0x1768,0x178f,0x17b9,0x17df,
0x1808,0x182e,0x1856,0x187e,0x18a6,0x18cd,0x18f6,0x191d,0x1945,0x196d,0x1995,0x19bd,0x19e6,0x1a0d,0x1a36,
0x1a5e,0x1a85,0x1aad,0x1ad4,0x1afc,0x1b23,0x1b4c,0x1b73,0x1b9c,0x1bc4,0x1bec,0x1c14,0x1c3b,0x1c64,0x1c8c,
0x1cb3,0x1cdb,0x1d03,0x1d2b,0x1d53,0x1d78,0x1d9c,0x1dbf,0x1de2,0x1e0a,0x1e32,0x1e5b,0x1e81,0x1eaa,0x1ed4,
0x1f01,0x1f31,0x1f5a,0x1f83,0x1faa,0x1fd1,0x1ff9,0x2022,0x204a,0x2071,0x2099,0x20c1,0x20e9,0x2111,0x2139,
0x2160,0x2188,0x21b0,0x21d9,0x2200,0x2228,0x2250,0x2279,0x22a2,0x22ca,0x22f2,0x2318,0x2340,0x2366,0x238b,
0x23b4,0x23e0,0x2407,0x2430,0x2458,0x2480,0x24a8,0x24d0,0x24f7,0x251e,0x2546,0x256e,0x2596,0x25bd,0x25e2,
0x260c,0x2635,0x265d,0x2685,0x26ac,0x26d4,0x26fd,0x2725,0x274d,0x2775,0x279d,0x27c4,0x27ed,0x2814,0x283c,
0x2864,0x288d,0x28b4,0x28dd,0x2904,0x292d,0x2955,0x297c,0x29a3,0x29ca,0x29f3,0x2a1c,0x2a43,0x2a6b,0x2a91,
0x2ab9,0x2ae2,0x2b0b,0x2b32,0x2b5c,0x2b82,0x2ba9,0x2bd0,0x2bfa,0x2c20,0x2c4a,0x2c72,0x2c9b,0x2cc1,0x2cea,
0x2d10,0x2d38,0x2d61,0x2d8a,0x2db0,0x2dd9,0x2e00,0x2e29,0x2e50,0x2e78,0x2ea0,0x2ec8,0x2ef0,0x2f18,0x2f40,
0x2f68,0x2f8f,0x2fb7,0x2fde,0x3007,0x3030,0x3058,0x307e,0x30a5,0x30cd,0x30f5,0x311d,0x3144,0x316c,0x3194,
0x31bb,0x31e4,0x320d,0x3235,0x325d,0x3286,0x32ae,0x32d7,0x32fd,0x3323,0x334c,0x3373,0x339c,0x33c4,0x33ec,
0x3416,0x343c,0x3463,0x348c,0x34b4,0x34dc,0x3504,0x352d,0x3554,0x357c,0x35a2,0x35ca,0x35f1,0x361b,0x3645,
0x366a,0x3692,0x36ba,0x36e2,0x370a,0x3733,0x375a,0x3782,0x37ab,0x37d3,0x37f9,0x3820,0x3847,0x386e,0x3896,
0x38c0,0x38e9,0x3912,0x393a,0x3963,0x398a,0x39b1,0x39db,0x3a02,0x3a2a,0x3a52,0x3a79,0x3aa2,0x3aca,0x3af2,
0x3b1c,0x3b48,0x3b6c,0x3b91,0x3bb8,0x3be0,0x3c08,0x3c31,0x3c59,0x3c80,0x3ca8,0x3cd0,0x3cf8,0x3d1f,0x3d49,
0x3d70,0x3d96,0x3dbe,0x3de5,0x3e0e,0x3e36,0x3e5e,0x3e86,0x3eae,0x3ed6,0x3efe,0x3f26,0x3f4e,0x3f76,0x3f9f,
0x3fc7,0x3fee,0x4015,0x403d,0x4065,0x408d,0x40b4,0x40dc,0x4104,0x412c,0x4154,0x417d,0x41a5,0x41cc,0x41f3,
0x421b,0x4242,0x426b,0x4293,0x42bb,0x42e3,0x430b,0x4333,0x435a,0x4381,0x43aa,0x43d2,0x43f9,0x4422,0x444a,
0x4472,0x449a,0x44c2,0x44ea,0x4512,0x4539,0x4562,0x458a,0x45b1,0x45d8,0x4601,0x4629,0x4654,0x467b,0x46a1,
0x46c9,0x46f0,0x4718,0x4740,0x4768,0x4791,0x47ba,0x47e1,0x4808,0x482f,0x4857,0x487e,0x48a7,0x48d0,0x48f8,
0x4920,0x4947,0x496e,0x4996,0x49be,0x49e6,0x4a0c,0x4a35,0x4a5d,0x4a84,0x4aac,0x4ad5,0x4afd,0x4b23,0x4b49,
0x4b71,0x4b98,0x4bc0,0x4be6,0x4c0d,0x4c33,0x4c5d,0x4c82,0x4cad,0x4cd7};

/*note read(int i ){
    
 int  a =  IORD_16DIRECT(BEATCONTROLLER_INST_BASE, i*2);  
  note b ; 
  b.color = (a&0xe000)>>13;
  b.timestamp = a&0x1fff;
  return b ;  
}*/
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////



static void  input_isr ( void* context, alt_u32 id)
{
    valz++;
    IOWR_16DIRECT(INPUTCONTROLLER_INST_BASE, 0,0);
   return;
}

//
//
//void sleep (unsigned int delay) {
//    unsigned int target = peek(0x33) + delay;
//    while (peek(0x33) != target);
//}

//
//

///////////////////////////////////////////////////////////////////////////////////////////////////////////:

int main()
{
    
     //  clock_t start, end;
    // double cpu_time_used;
     
  //   start = clock();
    /* Do the work. */
  /*   end = clock();
     cpu_time_used = ((double) (end - start)) / CLOCKS_PER_SEC;
     printf("%d\n", cpu_time_used);
    
    
    /* Obtain current time as seconds elapsed since the Epoch. */
   // time_t clock = time(NULL);
 
    /* Convert to local time format and print to stdout. */
   // printf("Current time is %s", ctime(&clock));
    
    
    ///////////////////////
   // time_t start,end;
//start=clock();//predefined  function in c
//after the user defined function does its work
//sleep(1000);

//end=clock();
//int s = start;
//int e = end;
//int t=(end-start);//CLOCKS_PER_SEC;
//printf("%d\n",s);
//printf("%d\n",e);
//printf("%d\n",t);
//printf("%d\n",difftime(start,end));
    ///////////////////////
    
    
    ///////////////////////
    ///////////////////////
    
   // printf("%d\n",IORD_16DIRECT(TIMER_INST_BASE, 0));
 //   printf("%d\n",IORD_16DIRECT(TIMER_INST_BASE, 2));
    
    //  IOWR_16DIRECT(TIMER_INST_BASE, 0, 0x0000FFFF);
     //  IOWR_16DIRECT(TIMER_INST_BASE, 2, 0xFFFF0000 ); 
   
  
    // printf("%d\n",IORD_16DIRECT(TIMER_INST_BASE, 0));
   // printf("%d\n",IORD_16DIRECT(TIMER_INST_BASE, 2));
   ///////////////////////////
   //////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////
    IOWR_8DIRECT(INPUTCONTROLLER_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER2_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER3_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER4_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER5_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER6_INST_BASE, 0, 0);

printf("main() started\n");

alt_irq_register( INPUTCONTROLLER_INST_IRQ, NULL,(void*)irqhandler ); // register the irq

alt_irq_register( INPUTCONTROLLER2_INST_IRQ, NULL,(void*)irqhandler2 ); // register the irq

alt_irq_register( INPUTCONTROLLER3_INST_IRQ, NULL,(void*)irqhandler3 ); // register the irq

alt_irq_register( INPUTCONTROLLER4_INST_IRQ, NULL,(void*)irqhandler4 ); // register the irq

alt_irq_register( INPUTCONTROLLER5_INST_IRQ, NULL,(void*)irqhandler5 ); // register the irq

alt_irq_register( INPUTCONTROLLER6_INST_IRQ, NULL,(void*)irqhandler6 ); // register the irq

printf("main() startewwwwd\n");
////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    
    // value from the buffer may be displayed, no worries
  printf("Hello from Nios II!\n");
 // alt_irq_register(1, (void*)0, input_isr);
    printf("Hello from Nios II!\n");
      printf("Hello from Nios II!\n");
 
 int counter = 0;
/*  for(counter = 0 ; counter < 3 ; counter ++){
    printf("%d!\n",3-counter);
  set_timer(1,0 );
  //printf("I\n");
   launch_timer();
   //printf("II\n");
    while(1){
        //printf("III\n");
      //  printf("%d\n",difftime(clock(),start));
      /* Obtain current time as seconds elapsed since the Epoch. */
    //clock = time(NULL);
 
    /* Convert to local time format and print to stdout. */
   // printf("Current time is %s", ctime(&clock));
  
   //clock_t end0;
    // double cpu_time_used0;
     
     
   //  end0 = clock();
   //  cpu_time_used0 = ((double) (end0 - start)) / CLOCKS_PER_SEC;
   //  printf("%s\n", cpu_time_used0);
    
 /*   
    if(timer_expired() ==1)
     break;  
  
   }
   
  }
  /*
  printf("Hello from Nios II %d!\n",valz);
  printf("Hello from Nios II!\n");
 
  printf("GO\n");
  counter = 0;
  counter = 0;
  for(counter = 0 ; counter < 3 ; counter ++){
    printf("%d!\n",3-counter);
  set_timer(1,0 );
   launch_timer();
    while(1){
    if(timer_expired() ==1)
     break;  
  
   }
   
  }
  */
  /*
    printf("Hello from Nios II %d!\n",valz);
  printf("Hello from Nios II!\n");
  counter = 0;
  for(counter = 0 ; counter < 3 ; counter ++){
    printf("%d!\n",3-counter);
  set_timer(1,0 );
   launch_timer();
    while(1){
    if(timer_expired() ==1)
     break;  
  
   }
   
  }
    printf("Hello from Nios II %d!\n",valz);
  printf("Hello from Nios II!\n");
  
  */
  int flag = 0;
  int val_buffer = val;
int key_buffer = floor(rand(5));


int score = 0; 

  while(counter<540){
    
    


if (flag!=1){
if (val>val_buffer){
if (key==key_buffer){
flag = 1;
score = score+1;
//printf("SUCCESS: %d triggered by %d\n",val,key);}}
printf("SUCCESS: SCORE %d\n",score);}}}
// rajouter booleen pour afficher succes qu'une seule fois
    
    //printf("%d\n",beat_counter);
    
    //if (beat_counter>=(beats[counter]*2000000)){
    if (beat_counter>=(beats[counter])*3){
                
        if (flag == 0){
printf("FAIL: SCORE %d\n",score);}

flag = 0;
val_buffer = val;
key_buffer = floor(1+rand()%5);

        printf("PRESS %d\n",key_buffer);
        counter=counter+1;
    }
    
  }
  
  printf("FINISHED!");
  
  
  //////////
//int flag = 0;
///////////
  
  while(counter<541){
    
    if(counter>0){
       set_timer(0,beats[counter]*40 - beats[counter-1]*40 );}
  else{
     set_timer(0,beats[counter]*40);
  }

//////////
//flag = 0;
//int val_buffer = val;
//int key_buffer = floor(rand(5));
///////////
  
 launch_timer();
   while(1){
    if(timer_expired() ==1)
     break;  
  
/////////////////////
//if (read_timer()==2000){ // c normal
//if (val>val_buffer){
//if (key==key_buffer){
//flag = 1;
//printf("SUCCESS: %d triggered by %d\n",val,key);}}}
// rajouter booleen pour afficher succes qu'une seule fois
////////////////////

   }


/////////////////////
if (flag == 0){
printf("FAIL");}
////////////////////


 printf("[%d] %d \n",counter, beats[counter]*40 );
   
 counter=counter+1;
 
  }
  
  
  return 0;
}
/*
int main()
{
    IOWR_8DIRECT(INPUTCONTROLLER_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER2_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER3_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER4_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER5_INST_BASE, 0, 0);
    IOWR_8DIRECT(INPUTCONTROLLER6_INST_BASE, 0, 0);

printf("main() startewwwwd\n");

alt_irq_register( INPUTCONTROLLER_INST_IRQ, NULL,(void*)irqhandler ); // register the irq

alt_irq_register( INPUTCONTROLLER2_INST_IRQ, NULL,(void*)irqhandler2 ); // register the irq

alt_irq_register( INPUTCONTROLLER3_INST_IRQ, NULL,(void*)irqhandler3 ); // register the irq

alt_irq_register( INPUTCONTROLLER4_INST_IRQ, NULL,(void*)irqhandler4 ); // register the irq

alt_irq_register( INPUTCONTROLLER5_INST_IRQ, NULL,(void*)irqhandler5 ); // register the irq

alt_irq_register( INPUTCONTROLLER6_INST_IRQ, NULL,(void*)irqhandler6 ); // register the irq

printf("main() startewwwwd\n");


int i = 0 ;
for (;;) {
    if ((i&0xffff) == 1 )
    printf("%d triggered by %d\n",val,key);
    i++;
    } // Do nothing forever
return 0; // Never executed
}
*/
/////////////////////////////////////////////////////////////////////////////////////////////////////////:
